<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
                template="./../plantilla-principal.xhtml"
                xmlns="http://www.w3.org/1999/xhtml"
                xmlns:h="http://xmlns.jcp.org/jsf/html"
                xmlns:pt="http://xmlns.jcp.org/jsf/passthrough"
                xmlns:f="http://xmlns.jcp.org/jsf/core"
                xmlns:jsf="http://xmlns.jcp.org/jsf">

    <ui:define name="contenido">
        <h:form prependId="false" id="form-menu" class="ui menu">
            <div class="header item">
                <div style="font-size: 22px">                    
                    <i class="list alternate outline icon" />
                    Generar facturas
                </div>
            </div>
            <div class="right menu">
                <div class="item">
                    Clientes
                    <div class="ui teal label">
                        #{genFacturaManBean.lstClientesGenerar.size()}
                    </div>
                </div>
                <div class="item">
                    Suscripciones
                    <div class="ui teal label">
                        #{genFacturaManBean.totalSuscripiones}
                    </div>
                </div>
                <div class="item">
                    Facturas
                    <div class="ui teal label">
                        #{genFacturaManBean.totalFacturas}
                    </div>
                </div>
                <div class="item">
                    <h:commandLink style="#{empty genFacturaManBean.lstFacturasGeneradas?'display:none':''}" class="ui icon button" action="#{genFacturaManBean.vistaPreviaImpresion()}" pt:data-tooltip="Vista previa de impresión" pt:data-inverted="" pt:data-position="bottom right">
                        <i class="print icon" />
                    </h:commandLink>

                    <h:commandLink action="#{genFacturaManBean.limpiar()}" style="margin-left: 5px" class="ui icon button" pt:data-tooltip="Limpiar" pt:data-inverted="" pt:data-position="bottom right">
                        <i class="eraser icon" />
                        <f:ajax execute="@this" render="tablaClientes cmlAgregar form-menu" />
                    </h:commandLink>

                    <div id="btn-generar" onclick="$('#cml-generar').click();" style="#{empty genFacturaManBean.lstClientesGenerar?'display: none;':'margin-left: 5px;'}" class="ui green icon button" data-tooltip="Generar facturas" data-inverted="" data-position="bottom right"> 
                        <i class="magic icon" />
                    </div>

                </div>
            </div>
        </h:form>
        <div class="ui grid">
            <div class="six wide column">
                <!--<h:form id="form-datos-generar" style=" margin-top: -15px" prependId="false">-->
                <div class="ui segments">
                    <div  class="ui red segment">
                        <h:form id="form-generar" prependId="false" class="ui form">
                            <div id="fieldFechaFacturas" class="field">
                                <label>Fecha de facturas</label>
                                <div class="ui calendar" id="cal-fechafactura">
                                    <div class="ui input">
                                        <h:inputText id="in-fechafacturas" pt:placeholder="Fecha" value="#{genFacturaManBean.strFechaFactura}" />
                                    </div>
                                </div>
                            </div>
                            <div id="fieldTalonario" class="field">
                                <label>Talonario</label>
                                <div class="ui selection dropdown">
                                    <h:inputHidden id="in-idtalonario" value="#{genFacturaManBean.idTalonarioSeleccionado}"/>
                                    <i class="dropdown icon"></i>
                                    <div class="default text">Talonario</div>
                                    <div class="menu">
                                        <ui:repeat value="#{genFacturaManBean.talonariosDisponibles}" var="talon" varStatus="talonStatus">
                                            <div class="item" data-value="#{talon.idtalonario}">
                                                #{talon.codEstablecimiento} | Actual: 
                                                <h:outputText value="#{talon.nroActual}">
                                                    <f:convertNumber pattern="#,###,###,###" />
                                                </h:outputText>
                                                | Fin:
                                                <h:outputText value="#{talon.nroFin}">
                                                    <f:convertNumber pattern="#,###,###,###" />
                                                </h:outputText>
                                                | Disp:
                                                <h:outputText value="#{talon.nroFin-talon.nroActual}">
                                                    <f:convertNumber pattern="#,###,###,###" />
                                                </h:outputText>
                                            </div>
                                        </ui:repeat>
                                    </div>
                                </div>
                            </div>
                            <h:commandLink style="display: none" id="cml-generar" action="#{genFacturaManBean.generarFacturas()}" onclick="return validarGeneracion()">
                                <f:ajax execute="@form" render="msg tablaClientes form-menu" onevent="function(data){ajaxGenerarFacturas(data)}" />
                            </h:commandLink>
                        </h:form>
                    </div>
                    <div class="ui orange segment">
                        <h:form id="form-agregar" prependId="false" class="ui form">
                            <div class="two fields">
                                <div id="fieldCantidadCuotas" class="field">
                                    <label>Max. cuotas por susc.</label>
                                    <h:inputText id="in-cant-cuotas" pt:type="number" value="#{genFacturaManBean.cantCuotasDef}" pt:placeholder="2" />
                                </div>
                                <div id="fieldItemsPorFact" class="field">
                                    <label>Max. items por factura</label>
                                    <h:inputText id="in-max-items-factura" value="#{genFacturaManBean.maxItemsPorFactura}" pt:type="number" pt:placeholder="4" />
                                </div>
                            </div>
                            <div id="fieldClienteCobrador" class="field">
                                <label>
                                    <div class="ui radio checkbox">
                                        <input id="rdbAgreCli" name="rdbcobrasusc" checked="checked" type="radio" />
                                        <label>Clientes</label>
                                    </div>
                                    <div class="ui radio checkbox">
                                        <input id="rdbAgreCobra" name="rdbcobrasusc" type="radio" />
                                        <label>Cobradores</label>
                                    </div>
                                </label>
                                <div id="cmbCliente" class="ui search selection dropdown" >
                                    <h:inputHidden id="in-idclienteagregar" value="#{genFacturaManBean.idClienteAgregar}" />
                                    <i class="dropdown icon" />
                                    <div class="default text">Código, razón social o CI</div>
                                    <div class="menu">
                                    </div>
                                </div>
                                <div style="display: none;" id="cmbCobrador" class="ui search selection dropdown" >
                                    <h:inputHidden id="in-idcobradoragregar" value="#{genFacturaManBean.idCobradorAgregar}" />
                                    <i class="dropdown icon" />
                                    <div class="default text">Nombres y/o apellidos</div>
                                    <div class="menu">
                                    </div>
                                </div>
                            </div>
                            <h:inputHidden id="in-agregarporcliente" value="#{genFacturaManBean.agrePorCliente}" />
                            <h:commandLink id="cmlAgregar"  action="#{genFacturaManBean.agregarCliCobra()}" onclick="return validarAgregar();" class="#{empty genFacturaManBean.lstFacturasGeneradas?'ui right labeled icon button':'ui disabled right labeled icon button'}">
                                <i class="add icon" />
                                Agregar
                                <f:ajax execute="@form" render="tablaClientes form-menu" onevent="function(data){ajaxAgregar(data)}"/>
                            </h:commandLink>
                        </h:form>
                    </div>
                </div>
                <!--</h:form>-->
                <div jsf:id="msg" class="ui #{genFacturaManBean.tipoMsg} hidden message">
                    <i class="close icon"></i>
                    <div class="header">
                        <h:outputText id="cabeceraMsg" value="#{genFacturaManBean.cabeceraMsg}" />
                    </div>
                    <p><h:outputText id="cuerpoMsg" value="#{genFacturaManBean.cuerpoMsg}" /></p>
                </div>
            </div>
            <div class="ten wide column">
                <h:form prependId="false" class="ui breadcrumb">
                    <h:commandLink style="color: black; font-size: 16px;" class="section">
                        <i class="user icon" />
                        Clientes
                        <f:ajax render="tablaClientes" onevent="function(data){ajaxVerTodosClientes(data)}"  />
                    </h:commandLink>
                    <i style="display: none" id="brcIconCliente" class="right arrow icon divider" />
                    <a id="brcCliente" style="display: none; color: black;" class="section" onclick="retrocederVerSuscripciones()">
                        XXXXXX
                    </a>
                    <i style="display: none" id="brcIconSusc" class="right arrow icon divider" />
                    <a id="brcSuscripcion" style="display: none; color: black;">
                        YYYYYYY
                    </a>
                </h:form>
                <h:form prependId="false">
                    <h:inputHidden id="inIdClienteVer" value="#{genFacturaManBean.idClienteVer}" />
                    <h:commandLink style="display: none" id="cmlVerCliente" value="ver" >
                        <f:ajax execute="@form" render="tablaSuscripciones" onevent="function(data){ajaxVerCliente(data)}" />
                    </h:commandLink>
                </h:form>
                <h:form prependId="false">
                    <h:inputHidden id="idSuscripcionVer" value="#{genFacturaManBean.idSuscripcionVer}" />
                    <h:commandLink style="display:none" id="cmlVerSuscripcion" value="ver" >
                        <f:ajax execute="@form" render="tablaCuotas" onevent="function(data){ajaxVerSuscripcion(data)}" />
                    </h:commandLink>
                </h:form>
                <h:form prependId="false">
                    <table jsf:id="tablaClientes" class="ui disabled selectable orange table">
                        <thead>
                            <tr>
                                <th>Cliente</th>
                                <th>Cobrador</th>
                                <th class="collapsing right aligned">Susc.</th>
                                <th class="collapsing right aligned">Cuotas</th>
                                <th class="collapsing right aligned">Fact.</th>
                                <th class="collapsing right aligned">Total</th>
                                <th class="right aligned collapsing">
                                    <h:commandLink style="#{empty genFacturaManBean.lstFacturasGeneradas?'':'display: none'}" pt:data-tooltip="Quitar todos" pt:data-inverted="" action="#{genFacturaManBean.limpiarTablaClientes()}">
                                        <i class="large red remove icon" />
                                        <f:ajax render="@form form-menu" execute="@this" />
                                    </h:commandLink>
                                </th>
                            </tr>
                        </thead>
                        <tbody>
                            <ui:repeat value="#{genFacturaManBean.lstClientesGenerar}" var="cligen" varStatus="cligenStatus">
                                <tr class="#{empty genFacturaManBean.lstFacturasGeneradas?'':'disabled'}">
                                    <td style="cursor: pointer" onclick="verSuscripciones(#{cligen.cliente.idcliente}, '#{cligen.cliente.razonSocial}')"
                                        data-tooltip="Cód. Cliente: #{cligen.cliente.idcliente} | CI/RUC: #{not empty cligen.cliente.ci?cligen.cliente.ci:'(No registrado)'}#{not empty cligen.cliente.ci &amp;&amp; not empty cligen.cliente.dvRuc?'-':''}#{not empty cligen.cliente.ci &amp;&amp; not empty cligen.cliente.dvRuc?cligen.cliente.dvRuc:''}" data-inverted="">
                                        #{cligen.cliente.razonSocial}
                                    </td>
                                    <td style="cursor: pointer" onclick="verSuscripciones(#{cligen.cliente.idcliente}, '#{cligen.cliente.razonSocial}')">
                                        #{cligen.cliente.cobrador.nombres} #{cligen.cliente.cobrador.apellidos}
                                    </td>
                                    <td style="cursor: pointer" class="right aligned" onclick="verSuscripciones(#{cligen.cliente.idcliente}, '#{cligen.cliente.razonSocial}')">#{cligen.lstSuscripciones.size()}</td>
                                    <td style="cursor: pointer"  class="right aligned" onclick="verSuscripciones(#{cligen.cliente.idcliente}, '#{cligen.cliente.razonSocial}')">
                                        #{cligen.totalCuotasIncluidas}/#{cligen.totalCuotasIncluidas+cligen.totalCuotasExcluidas}
                                    </td>
                                    <td style="cursor: pointer" class="right aligned" onclick="verSuscripciones(#{cligen.cliente.idcliente}, '#{cligen.cliente.razonSocial}')">
                                        #{cligen.gruposCuotasGenerar.size()}
                                    </td>
                                    <td style="cursor: pointer" class="right aligned" onclick="verSuscripciones(#{cligen.cliente.idcliente}, '#{cligen.cliente.razonSocial}')">
                                        <h:outputText value="#{genFacturaManBean.getTotalCobrarCliente(cligen.cliente.idcliente)}">
                                            <f:convertNumber pattern="#,###,###,###" />
                                        </h:outputText>
                                    </td>
                                    <td style="cursor: pointer" class="right aligned">
                                        <h:commandLink pt:data-tooltip="Quitar cliente" pt:data-inverted="" pt:data-position="left center" action="#{genFacturaManBean.quitarCliente(cligen.cliente.idcliente)}">
                                            <i class="large red remove icon" />
                                            <f:ajax render="@form form-menu" execute="@this"  />
                                        </h:commandLink>
                                    </td>
                                </tr>
                            </ui:repeat>
                            <tr id="colVaciaCliente" class="disabled center aligned" jsf:rendered="#{empty genFacturaManBean.lstClientesGenerar}">
                                <td colspan="7">(Ningún cliente)</td>
                            </tr>
                        </tbody>
                    </table>
                </h:form>
                <table style="display: none" jsf:id="tablaSuscripciones" class="ui teal table">
                    <thead>
                        <tr>
                            <th class="collapsing">Cód.</th>
                            <th>Servicio</th>
                            <th class="right aligned">Mensual</th>
                            <th class="right aligned">A Cobrar</th>
                            <th class="right aligned">Cuotas</th>
                        </tr>
                    </thead>
                    <tbody>
                        <ui:repeat value="#{genFacturaManBean.lstSuscripcionesCliente}" var="suscgen" varStatus="suscgenStatus">
                            <tr style="cursor: pointer" onclick="verCuotas(#{suscgen.suscripcion.idsuscripcion}, '#{suscgen.suscripcion.servicio.nombre}')">
                                <td>#{suscgen.suscripcion.idsuscripcion}</td>
                                <td>#{suscgen.suscripcion.servicio.nombre}</td>
                                <td class="right aligned">
                                    <h:outputLabel value="#{suscgen.suscripcion.precio}">
                                        <f:convertNumber pattern="#,###,###,###" />
                                    </h:outputLabel>
                                </td>
                                <td class="right aligned">
                                    <h:outputText value="#{suscgen.montoTotalGenerar}">
                                        <f:convertNumber pattern="#,###,###,###" />
                                    </h:outputText>
                                </td>
                                <td class="right aligned">
                                    #{suscgen.totalCuotasIncluidas}/#{suscgen.totalCuotasExcluidas+suscgen.totalCuotasIncluidas}
                                </td>
                            </tr>
                        </ui:repeat>
                        <tr style="color: gray;" class="center aligned" jsf:rendered="#{empty genFacturaManBean.lstSuscripcionesCliente}">
                            <td colspan="4">(Ninguna suscripción)</td>
                        </tr>
                    </tbody>
                </table>
                <h:form prependId="false">
                    <table style="display: none;" jsf:id="tablaCuotas" class="ui green table">
                        <thead>
                            <tr>
                                <th>Mes/Año Cuota</th>
                                <th>Concepto</th>
                                <th class="right aligned">Monto</th>
                                <th class="right aligned">Subtotal</th>
                                <th class="collapsing right aligned">Incluir</th>
                            </tr>
                        </thead>
                        <tbody>
                            <ui:repeat value="#{genFacturaManBean.listCuotasGenerar}" var="gcuo" varStatus="gcuoStatus">
                                <tr>
                                    <td>
                                        <ui:repeat value="#{gcuo.lstCuotas}" var="cuoVenc" varStatus="cuoVencStatus">
                                            #{utilConversion.getNombreMes(cuoVenc.mesCuota)}/#{cuoVenc.anioCuota}
                                            <br jsf:rendered="#{gcuo.lstCuotas.size()>1 &amp;&amp; not cuoVencStatus.last}" />
                                        </ui:repeat>
                                    </td>
                                    <td>
                                        <ui:repeat value="#{gcuo.lstCuotas}" var="cuoConc" varStatus="cuoConcStatus">
                                            #{cuoConc.servicio.nombre}
                                            <br jsf:rendered="#{gcuo.lstCuotas.size()>1 &amp;&amp; not cuoConcStatus.last}" />
                                        </ui:repeat>
                                    </td>
                                    <td class="right aligned">
                                        <ui:repeat value="#{gcuo.lstCuotas}" var="cuoMonto" varStatus="cuoMontoStatus">
                                            <h:outputText value="#{cuoMonto.montoCuota-cuoMonto.montoEntrega}">
                                                <f:convertNumber pattern="#,###,###,###" />
                                            </h:outputText>
                                            <br jsf:rendered="#{gcuo.lstCuotas.size()>1 &amp;&amp; not cuoMontoStatus.last}" />
                                        </ui:repeat>
                                    </td>
                                    <td class="right aligned">
                                        <h:outputText value="#{gcuo.subtotal}">
                                            <f:convertNumber pattern="#,###,###,###" />
                                        </h:outputText>
                                    </td>
                                    <td class="right aligned">
                                        <h:commandLink action="#{genFacturaManBean.incluirExcluirGrupo(gcuoStatus.index)}">
                                            <i class="#{gcuo.incluir?'green large check icon':'black large minus icon'}" />
                                            <f:ajax execute="@this" render="tablaCuotas form-menu" onevent="function(data){ajaxIncluirExcluir(data)}" />
                                        </h:commandLink>
                                    </td>
                                </tr>
                            </ui:repeat>
                        </tbody>
                    </table>
                </h:form>
            </div>
        </div>

        <h:outputScript target="body" library="js" name="facturas/generarfacturas.js" />
    </ui:define>

</ui:composition>
